<?php

namespace common\logic\User\User\Service;

use common\logic\AbstractUtils;
use common\logic\User\User\Model\User;

class AuthorizationChecker extends AbstractUtils
{
    protected UserSolver $userSolver;

    public function loadDependencies(): void
    {
        $this->userSolver = $this->loadService(UserSolver::class);
    }

    public function isGrantedAsAdministrator(User $user = null): bool
    {
        if(!$user) {
            return false;
        }

        return $this->userSolver->isStatusAdministrator($user);
    }

    public function isGrantedAsProducer(User $user = null): bool
    {
        if(!$user) {
            return false;
        }

        return $this->isGrantedAsAdministrator($user)
            || $this->userSolver->isStatusProducer($user);
    }

    public function isGrantedAsUser(User $user = null): bool
    {
        if(!$user) {
            return false;
        }

        return $this->isGrantedAsProducer($user)
            || $this->userSolver->isStatusUser($user);
    }
}